<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhPalivaEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\EmisnySystemEnum;

/**
 * Class ZoznamPoctuKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class ZoznamPoctuKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla extends ZoznamPoctuKontrolAbstract implements ZoznamPoctuKontrol
{
    /**
     * @inheritDoc
     */
    public function add(PocetKontrol $pocetKontrol)
    {
        $addNewRecord = true;

        if (!$pocetKontrol instanceof PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla) {
            throw new InvalidArgumentException(
                sprintf(
                    'Ocakava sa instancia triedy %s, vtupny atribut je instancie %s',
                    PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla::class,
                    get_class($pocetKontrol)
                )
            );
        }

        array_walk(
            $this->items,
            function (PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla &$pocetKontrolPodlaDruhuPalivaAEmisnehoSystemu, int $index) use ($pocetKontrol, &$addNewRecord) {
                if ($pocetKontrolPodlaDruhuPalivaAEmisnehoSystemu->equalsDruhPalivaAEmisnehoSystemu($pocetKontrol)) {
                    $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemu = $pocetKontrolPodlaDruhuPalivaAEmisnehoSystemu->navysitPocet($pocetKontrol);
                    $addNewRecord = false;
                }
            }
        );

        if ($addNewRecord) {
            $this->items[] = $pocetKontrol;
        }

        return new self($this->items);
    }

    /**
     * @inheritDoc
     */
    public static function createFromArray(array $udaje): ZoznamPoctuKontrolAbstract
    {
        $zoznam = new self();

        foreach ($udaje as $udaj) {
            $zoznam->add(new PocetKontrolPodlaDruhuPalivaAEmisnehoSystemuVozidla(
                DruhPalivaEnum::make(mb_strtoupper($udaj['druh_paliva'])),
                empty($udaj['emisny_system']) ? EmisnySystemEnum::NULL() : EmisnySystemEnum::make(mb_strtoupper($udaj['emisny_system'])),
                (int) $udaj['pocet']
            ));
        };

        return $zoznam;
    }
}
